DIGJUMP - Editorial

PROBLEM LINK:

Practice
Contest

Tester: Shiplu Hawlader
Editorialist: Praveen Dhinwa

DIFFICULTY:

Easy

PREREQUISITES:

bfs, dijkstra

PROBLEM:

Given a string s of N. You have to go from start of the string(index 0) to the end of the string (index N - 1).
From position i, you can go to next (i + 1) or previous (i - 1) position. You can also move from the current position to the indices where the
character is same as current character s[i].

QUICK EXPLANATION

  • Minimum number of operations can not be greater than 19.
  • By your moves, you will never be visiting a single digit more than twice.
  • You can solve this problem by a modified bfs.
  • You can also make use of simple dijkstra’s algorithm.

EXPLANATION

Few observations

  • Minimum number of operations can not be greater than 19.
    Proof:
    You can start from first position and go to rightmost index where you can directly go.
    Then from that position go to next position and keep repeating the previous step.
    Note that you will be visiting a single number at most twice. Hence you can at most make 19 moves because first digit will be visited once.

    They will 19 in the cases of 001122334455667788999.

  • By your moves, you will never be visiting a single digit more than twice.
    Proof:
    If you are using more than 2 moves for going from a digit to another, you can simply reduce one of the move by simply going from
    one of the position to other in just a single move. So you can simply keep the at most 2 moves for moving from a digit to another.

Wrong greedy strategies
Let us first discuss about some greedy strategies and figure out the reason why they are wrong.

From the current position, go to the rightmost index having same character/digit as the current character/digit.
If this number does not occur again in the right part of array, then go to next position (ie. i + 1).

Please see the following recursive implementation of this strategy.

Pseudo Code

def greedy(int cur):
	// cur = N denotes end/ target position.
	if (cur = N) return 0;
	last = cur + 1;
	for i = cur + 1 to N:
		if (s[i] == s[pos]):
			last = i;
	return 1 + greedy(cur);

The above strategy will fail in these kind of cases:
010000561
According to greedy strategy, From 0, you will go to rightmost 0, then from that position to 5, then to 6 and finally you will go to 1.
Total number of operations required are 4.
But you can do it in simply 2 operations. Go from 0 to 1 and then go to rightmost 1 (target position).

Wrong dp algorithm
Some contestants have used wrong dp algorithm. Let dp[i] denote the minimum number of moves needed to reach position i from position 0.
Some wre considering the transition from (i - 1) th position to i or
from some position j < i (such that digit at j is same as digit at i.) to i.

Note that this kind of dp solutions are wrong because they don’t consider the moves going backwards (from position i to i - 1), they are only
considering the forward moves.

A simple test case where they will fail.
In the case: 02356401237894, dp program will give answer 6, but we can go from position 0 to 6 and then to 4 on the left side of
second 0 (backward move) and then directly go to 4.
So total number of operations required are 3.

Bfs Solution
Now consider the movement operations from one position to other to be edges of the graph and indices of the string as nodes of the graphs.
Finding minimum number of operations to reach from 0 to N - 1 is equivalent to finding shortest path in the graph above mentioned. As
the weights in the give graph are unit weights, we can use bfs instead of using dijkstra’s algorithm.

So we can simply do a bfs from our start node(index 0) to end node(index n - 1).
Number of nodes in the graph are n, but the number of edges could
potentially go up to N 2 (Consider the case of all 0’s, entire graph is a complete graph.).

Optimized bfs Solution
Now we will make use of the 2 observations that we have made in the starting and we will update the bfs solution accordingly.
Whenever you visit a vertex i such that then you should also visit all the the indices j such that s[j] = s[i] (this follows directly
from observation 2). Now you can make sure to not to push any of the indices having digit same as current digit because according to observation 2,
we are never going to make more than 2 moves from a position to another position with same digit, So after adding that the current character, you should make sure that you are never going to visit any vertex with same value as s[i].

For a reference implementation, see Vivek’s solution.

Another Easy solution
Credit for the solution goes to Sergey Nagin(Sereja).

Let dp[i] denote the number of steps required to go from position 0 to position i.
From the previous observations, we know that we wont need more than 20 steps.
So lets make 20 iterations.

Before starting all the iterations, we will set dp[1] = 0 and dp[i] = infinity for all other i > 1.
On each iteration, we will calculate Q[k] where Q[k] is the minimum value of dp[i] such that s[i] = k.
ie. Q[k] denotes the minimum value of dp over the positions where the digit is equal to k.

We can update the dp by following method.
dp[i] = min(dp[i], dp[i - 1] + 1, dp[i + 1] + 1, Q[s[i]] + 1);

Here the term dp[i - 1] + 1 denotes that we have come from previous position ie (i - 1).
Here the term dp[i + 1] + 1 denotes that we have come from next position ie (i + 1).
The term Q[s[i]] + 1 denotes the minimum number of operations needed to come from a position with same digit as the current i th digit.

Pseudo code:

// initialization phase.
dp[1] = 0;
for (int i = 2; i <= N; i++) dp[i] = inf;
for (int it = 0; it < 20; i++) {
	// Compute Q[k]
	for (int k = 0; k < 10; k++)
		Q[k] = inf;
	for (int i = 1; i <= n; i++) {
		Q[s[i] - '0'] = min(Q[s[i] - '0'], dp[i]); 
	}
	// Update the current iteration.
	for (int i = 1; i <= n; i++) {
		dp[i] = min(dp[i], dp[i - 1] + 1, dp[i + 1] + 1, Q[s[i] - '0'] + 1);
	}
}
// dp[n] will be our answer.

Proof
If you done proof of dijkstra’s algorithm, you can simply found equivalence between the two proofs.

Complexity:
Complexity is O(20 * N). Here 20 is max number of iterations.

AUTHOR’S AND TESTER’S SOLUTIONS:

Tester’s solution

60 Likes

what is wrong with my this DP solution its giving correct answer for 02356401237894 (3)

#include<stdio.h>
#define min(a,b) a<b?a:b
#define int_max 1000000
int main()
{
int jump[100005];

char num[100005];

scanf("%s",num);

int i;

jump[0] = 0;

for(i=0;i<100004;i++)
    jump[i] = 1000000;
jump[0] = 0;
for(i=1;num[i] != '\0';i++)
{
    int j = 0;
    //   jump[i] = 1000000;
    while(j<i)
    {   
        if( ( i == j+1 || num[i] == num[j]  ))
        {
            if(jump[i] > jump[j] + 1)
                jump[i] = jump[j] + 1;

            break;                
        }


        j = j+1;
    }
    if( jump[i-1]  > jump[i] + 1)
        jump[i-1] = jump[i] + 1;
    if(jump[i+1] != '\0' && jump[i+1] > jump[i] + 1)
        jump[i+1] = jump[i] + 1;
    //     printf("%d",j);
}
printf("%d\n",jump[i-1]);
return 0;

}

1 Like

Can you explain what is wrong with my dp solution. It gave right answer for your test case. I have implemented the dp such that it considers going backwards.

#include
#include
#include
#include
#include

using namespace std;

int main() {
int dp[100005];
string s;
cin>>s;
int len = s.size();
//cout<<s.size()<<endl;
int mini[10];
memset(mini,-1,sizeof(mini));
for(int i=0;i<len;i++)
dp[i] = 100005;

dp[0] = 0;
mini[s[0]-'0']=0;
int curMin,j;
for(int i=1;i<len;i++)
{
	if(mini[s[i]-'0']==-1)
		mini[s[i]-'0']=i;
	
	curMin = dp[mini[s[i]-'0']];
	dp[i] = min(dp[i-1]+1, curMin+1);
	if(dp[i] < dp[mini[s[i]-'0']])
		mini[s[i]-'0'] = i;
	
	j=i;
	while((dp[j-1] > (dp[j]+1))&&(j!=(len-1)))
	{
		dp[j-1] = dp[j]+1;
		if(dp[j-1] < dp[mini[s[j-1]-'0']])
			mini[s[j-1]-'0'] = (j-1);
		j--;
	}
}
/*
cout<<endl;

cout<<mini[3]<<endl;*/
/*for(int i=0;i<len;i++)
	cout<<dp[i];
cout<<endl;*/
cout<<dp[len-1];
return 0;

}

Please it will be great if someone can explain to me my mistake here. My approach is similar to Sergey’s approach. My mini array does the same thing that the Q array does in his code

2 Likes

Can someone point out the bug in my Greedy problem as well, it gives me WA.
Thanks in advance :slight_smile:

#include<iostream>
#include<string>
#include<algorithm>
#include<vector>

using namespace std;
struct intint
{
	int number;
	int start;
	int end;
	int jump;
};

bool compareJumps(intint a,intint b) { return (a.jump > b.jump); }

bool isCompatible(vector<intint> baseVector, intint toCheck)
{
	for(int i=0;i<baseVector.size();i++)
	{
		if((toCheck.start < baseVector[i].start) && (toCheck.end < baseVector[i].start))
		{}
		else if((toCheck.start > baseVector[i].end) && (toCheck.end > baseVector[i].end))
		{}
		else
		{
			return false;
		}
	}
	return true;
}

int main()
{
	string S;
	cin>>S;
	vector<intint> max;
	for(int i=0;i<10;i++)
	{
		intint temp;
		temp.number = i;
		temp.jump = -1;
		temp.start = -1;
		temp.end = -1;
		max.push_back(temp);
	}
	for(int i=0;i<S.length();i++)
	{
		int number = S[i] - 48;
		if(max[number].start == -1)
		{
			max[number].start = i;
			//max[number].jump = 0;
		}
		else
		{
			max[number].end = i;
			max[number].jump = i - max[number].start;
		}
	}
	sort(max.begin(),max.end(),compareJumps);
	vector<intint> jumpsTaken;
	for(int i=0;i<max.size();i++)
	{
		if((max[i].jump > 0)&&(isCompatible(jumpsTaken,max[i])))
		{
			jumpsTaken.push_back(max[i]);
		}
	}
	int path = S.length() - 1;
	for(int i=0;i<jumpsTaken.size();i++)
	{
		path = path - jumpsTaken[i].jump + 1;
	}
	cout<<path;
	return 0;
}

Great Observations. Used BFS for this question. i wish, if i had thought of this bfs optimisation before. great question

1 Like

I used O(2^8*8!), cause was not able to come up with easier approach. omg ))

My solution was accepted and uses dynamic programming. However because the solution is based on my intuition I’m not sure if understand whether or why it’s 100% correct.

let dp[i] represent the minimum amount of steps in order to reach position i of the input array. We want to find dp[N-1].

let nums be an array of size 10 where nums[i] represents the minimum amount of moves that are needed in order to reach number i. Note that this number can exist anywhere in the array.

Now we have to scan the array from left to right and then from right to left as many times as needed in order to calculate the final value for dp[N-1]. We stop scanning the array when the values of dp aren’t changed from a single scan (left->right, right->left).

Initialization

all values of dp and nums to INF
dp[0] = 0
nums[number of input[0]] = 0

First we scan it from left to right.

dp[i] = min(dp[i], dp[i-1]+1, nums[number of input[i]]+1)

then we scan the array from right to left:

dp[i] = min(dp[i], dp[i+1]+1, nums[number of input[i]]+1)

then again from left to right, right to left etc, until nothing changes in the array dp.

Basically I assume that the convergence to a solution is fast, however I have yet to think of a proof to this.

6 Likes

Hi All

I used the BFS and dijsktra approach to solve the problem . It is working fine for all cases mentined above .Please have a look at it and would be grateful to let me know whch testcases it failed . Thanks :slight_smile:

http://www.codechef.com/viewsolution/4092676

1 Like

Can anyone tell me what is wring with this code, it gives wrong answer on submission, but is working fine on my system for every possible input i can think of. I am not able to find the type of input for which it can give a wrong answer.

http://www.codechef.com/viewsolution/4105903

Who are getting WA can have the following cases :

94563214791026657896112 ans -> 4

12345178905 ans -> 3

112 ans -> 2

1112 ans -> 2

4589562452263697 ans -> 5

14511236478115 ans -> 2

0123456754360123457 ans -> 5

14 Likes

Author’s solution link is broken. http://www.codechef.com/download/Solutions/2014/June/Setter/DIGJUMP.cpp
Please fix the link.

We can solve it using a Dijkstra too without relying on the fact that the solution would be bounded by 20. Instead of interconnecting all nodes with the same digit value resulting in potentially ~V^2 edges, we create one super node for each digit from 0 to 9, and connect each digit with its corresponding super node with an edge of weight 0.5. We can thus move to and from same digit nodes in distance 1, which was exactly what was required. This results in ~V edges and we can run Dijkstra on the first node in VlogV time. Finally we can double all edge lengths to avoid floating points and divide the required distance by 2 at the end.

16 Likes

If you are finding “Wrong Answer” then try following testcase :-

0998887776665554443322223300885577

Correct Ans --> 5

Directions : 0,0(last occurrence),8(next),8(index:5),7(next),7(last)

6 Likes

I tried the DP thing, iterating over it and making it better, made a lot of submissions in the process. Here is my last one I tried:

from __future__ import division
def read_mapped(func=lambda x:x):
    return map(func, raw_input().strip().split(" "))
def read_int():
    return int(raw_input().strip())
def read_str():
    return raw_input().strip()
def read_float():
    return float(raw_input().strip())
 
s = map(int, list(read_str()))
lim = len(s)-1
dp = [-1 for _ in xrange(lim+1)]
dp[0] = 0

from collections import defaultdict
dpa = [10**10 for i in xrange(11)]
dpa[s[0]] = 0
 
for i in xrange(1, lim+1):
    minn = dpa[s[i]]
    dp[i] = min(minn, dp[i-1])+1
    dpa[s[i]] = min(dpa[s[i]]+1, dp[i])

for _ in xrange(19):
    dpa = [10**10 for i in xrange(11)]
    dpa[s[0]] = 0
    for i in xrange(1, lim+1):
        minn = dpa[s[i]]
        dp[i] = min(minn, dp[i-1], dp[i+1] if i!=lim else 10**10)+1
        dpa[s[i]] = min(dpa[s[i]]+1, dp[i])

print dp[-1]

But it gives me a WA. Why is it so?

Edit

I tried chanakya’s input and it gives me 8 as answer instead of 3. I can’t figure out why. :confused:

Input:
0998887776665554443322223300885577

Output:
8

Can anyone tell me what i am commiting mistake in my code…

#include<bits/stdc++.h>
using namespace std;
string str;
int a[10][10],flag[10];

void distance_matrix()
{
int i,j;
for(i=0;i<str.size();i++)
{
if(i==0)
{
a[str[i]-‘0’][str[i+1]-‘0’]=1;
a[str[i]-‘0’][str[i]-‘0’]=0;
flag[str[i]-‘0’]=1;
}
else if(i==str.size()-1)
{
if(flag[str[i]-‘0’]==1)
{
a[str[i]-‘0’][str[i]-‘0’]=1;
a[str[i]-‘0’][str[i-1]-‘0’]=min(2,a[str[i]-‘0’][str[i-1]-‘0’]);
}
else
{
a[str[i]-‘0’][str[i]-‘0’]=0;
a[str[i]-‘0’][str[i-1]-‘0’]=1;
flag[str[i]-‘0’]=1;
}
}
else
{
if(flag[str[i]-‘0’]==1)
{
a[str[i]-‘0’][str[i]-‘0’]=1;
a[str[i]-‘0’][str[i+1]-‘0’]=min(2,a[str[i]-‘0’][str[i+1]-‘0’]);
a[str[i]-‘0’][str[i-1]-‘0’]=min(2,a[str[i]-‘0’][str[i-1]-‘0’]);
}
else
{
a[str[i]-‘0’][str[i]-‘0’]=0;
a[str[i]-‘0’][str[i+1]-‘0’]=1;
a[str[i]-‘0’][str[i-1]-‘0’]=1;
flag[str[i]-‘0’]=1;
}
}
}
/for(i=0;i<10;i++)
{
for(j=0;j<10;j++)
cout<<a[i][j]<<" ";
cout<<endl;
}
/
}

int main()
{
//freopen(“in.txt”,“r”,stdin);
//freopen(“out.txt”,“w”,stdout);
int n,i,j,k;
for(i=0;i<10;i++)
{
for(j=0;j<10;j++)
a[i][j]=INT_MAX/2;
flag[i]=0;
}
cin>>str;
if(str.size()==1)
{
cout<<“0”<<endl;
return 0;
}
distance_matrix();
int visit[10],distance[10];
for(i=0;i<10;i++)
{
visit[i]=0;
distance[i]=INT_MAX/2;
}
visit[str[0]-‘0’]=1;
for(i=0;i<10;i++)
{
distance[i]=a[str[0]-‘0’][i];
}
distance[str[0]-‘0’]=0;
/for(i=0;i<10;i++)
{
cout<<visit[i]<<" “;
}cout<<endl;
for(i=0;i<10;i++)
{
cout<<distance[i]<<” “;
}
for(i=0;i<10;i++)
{
for(j=0;j<10;j++)
cout<<a[i][j]<<” ";
cout<<endl;
}
/
for(i=0;i<10;i++)
{
int min_dis=INT_MAX/2,index;
for(j=0;j<10;j++)
{
if(visit[j]==0&&distance[j]<=min_dis)
{
min_dis=distance[j];
index=j;
}
}
visit[index]=1;
for(j=0;j<10;j++)
{
if(visit[j]==0)
{
distance[j]=min(distance[j],min_dis+a[index][j]);
}
}
}
/for(i=0;i<10;i++)
{
cout<<visit[i]<<" “;
}cout<<endl;
for(i=0;i<10;i++)
{
cout<<distance[i]+a[i][i]<<” ";
}
/
cout<<distance[str[str.size()-1]-‘0’]+a[str[str.size()-1]-‘0’][str[str.size()-1]-‘0’]<<endl;
return 0;
}

Well the test cases for this problem are still weak . Here is my accepted solution . My code fails on this 348117304825225015142699765169 . The expected output is 5 whereas my code gives 6
as the answer . I was almost half sure whether my solution would pass or not but luckily it passed . Its really difficult to make tricky test cases which can fail wrong solutions . I would request the setter to update the test cases for this problem in the practice section if possible .

11 Likes

i have checked all the test cases given here for each one my code is giving correct output.
can any one tell me for which test case it got failed.@admin…I think for this problem it will be helpful for many of us if test cases used for evaluation be made public.

thanks

3 Likes

http://www.codechef.com/viewsolution/4050931

Can someone check my this code. it is showing run time error. but in my compiler it is providing me with all correct answers. help would be appreciated.

I am not able to understand under the heading “Another Easy Solution” DP.
Pseudo Code is not working for me but using the idea I solved the problem.
So i change the code for moving from position 0 to n-1 .(rather than from 1 to n).

dp[0]=0 ;
dp1 =1;

Answer is given by dp[n-1]

My Solution link is http://www.codechef.com/viewsolution/4110410

I’ve used a solution similar to the one by Sergey Nagin.
I have, however, used 10 iterations instead of 20. I got AC which could be due to weak test cases.

Can someone please give a test case that shows the possible mistake in my code?
Or is it actually possible to do it in 10 and not 20 iterations?

The following arrays in my code have the following meaning as in the pseudo code by Sergin.
val[i] - dp[i] (stores minimum no of moves to reach this point)
minval[i] - Q[i] (stores minimum no of moves to reach the number i)

#include<stdio.h>
#include<string.h>
int main()
{

int i,n;    
char str[100000];
int minval[10],val[100001];
scanf("%s",str);
n = strlen(str);

val[0]=0;
val[n]=20000;
for(i=0;i<n;i++) str[i]=str[i]-48;
for(i=0;i<10;i++) minval[i]=20;
minval[str[0]]=0;

for(i=0;i<n;i++)
{
    if(i!=0)
    {
        if(val[i-1]<=minval[str[i]])
        {
            val[i]=val[i-1]+1;
        }
    else
    {
        val[i]=minval[str[i]]+1;
    }

    if(minval[str[i]]>val[i]) minval[str[i]]=val[i];
}

if(minval[str[i]]>val[i]) minval[str[i]]=val[i];


}
int j;
for(j=0;j<10;j++)
{


    for(i=0;i<n;i++)
    {
        if( i!=0)
        {
            if(val[i-1]<minval[str[i]]&&val[i-1]<val[i+1])
            {
                val[i]=val[i-1]+1;
            }
            else if(val[i+1]<minval[str[i]]&&val[i+1]<val[i-1])
            {
                val[i]=val[i+1]+1;
            }
            else
            {
                val[i]=minval[str[i]]+1;
            }
            if(minval[str[i]]>val[i]) minval[str[i]]=val[i];
        }
        if(minval[str[i]]>val[i]) minval[str[i]]=val[i];
    }
}
printf("%d\n",val[n-1]);

}